import java.io.*;

public class ConsoleApp {

	// the sub-process to run console application 
	private static Process proc = null;
	
	// the standard input pipe
	private static DataInputStream in = null;
	//private static DataOutputStream out = null;
	// the standard output pipe
	private static BufferedWriter out = null;

	// initialize the console program
	public static void init(String[] args) {
		Runtime runtime=Runtime.getRuntime();
		
		try {
			proc=runtime.exec("ConsoleApplication "+args[0]);
			in = new DataInputStream(proc.getInputStream());
			//out = new DataOutputStream(proc.getOutputStream());
			out = new BufferedWriter(new OutputStreamWriter(proc.getOutputStream()));
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
	// send the command to the console program
	public static void send(String cmd) {
		System.out.println("CONSOLE_SEND: "+cmd);
		try {
			//out.writeBytes(cmd+"\n");
			cmd+="\n";
			out.write(cmd,0,cmd.length());
			
			out.flush();
		} catch (Exception e) {
			//e.printStackTrace();
		}
	}

	// receive the audio data from the console program
	public static String recv() {
		String line = "";
		try {
			line = in.readLine();
		} catch (Exception e) {
			e.printStackTrace();
		}
		//System.out.println("CONSOLE_RECV: "+line);
		return line;
	}

	// close the pipe
	public static void close() {
		send("0");
		try {
			in.close();
			out.close();
		} catch (Exception e) {
			//e.printStackTrace();
		}
			
	}
	
	// if the data is available from the console program
	public static int available() {
		int num = -1;
		try {
			num = in.available();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return num;
	}
}
