import java.util.*;
import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;
import javax.swing.*;

// class to handle mail delivery
public class MailService {

	// send the message to the recipent
	public static void sendMessage(String recipent, String sender, String password, String msgText, String filename, String fileTextName) throws Exception {
//System.out.println(recipent+","+sender+","+password+","+msgText+","+filename);
		String host = "authusersmtp.mail.cornell.edu";
		boolean debug = false;
		String subject = "Singing Clip from multimedia system created by wc267, ac348, ss555";
		
		// create some properties and get the default Session
		Properties props = System.getProperties();
		props.put("mail.smtp.host", host);
		props.setProperty("mail.smtp.auth", "true");

		Authenticator auth = new PasswordAuthenticator(sender,password);
		Session session = Session.getDefaultInstance(props, auth);
		session.setDebug(debug);
		
		    // create a message
		    MimeMessage msg = new MimeMessage(session);
		    msg.setFrom(new InternetAddress(sender+"@cornell.edu"));
		    InternetAddress[] address = {new InternetAddress(recipent)};
		    msg.setRecipients(Message.RecipientType.TO, address);
		    msg.setSubject(subject);

		    // create and fill the first message part
		    MimeBodyPart mbp1 = new MimeBodyPart();
		    mbp1.setText(msgText);

		    // create the second message part
		    MimeBodyPart mbp2 = new MimeBodyPart();

	            // attach the file to the message
	   	    FileDataSource fds=new FileDataSource(filename);
		    mbp2.setDataHandler(new DataHandler(fds));
		    mbp2.setFileName(fileTextName);

		    // create the Multipart and its parts to it
		    Multipart mp = new MimeMultipart();
		    mp.addBodyPart(mbp1);
		    mp.addBodyPart(mbp2);

		    // add the Multipart to the message
		    msg.setContent(mp);

		    // set the Date: header
		    msg.setSentDate(new Date());
		    
		    // send the message
			Transport transport = session.getTransport("smtp");
			transport.send(msg);
			transport.close();
		    
	    }

}

// the class to handle the authentication of mail server
class PasswordAuthenticator extends Authenticator
{
	private String user = null;
	private String pass = null;

	public PasswordAuthenticator(String username, String password)
	{
		user = username;
		pass = password;
	}

	public PasswordAuthentication getPasswordAuthentication()
	{
		return new PasswordAuthentication(user, pass);
	}

}